unit hauptu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,jpeg, ExtCtrls, StdCtrls, ComCtrls,inifiles,math,XPMan,mmsystem,
  DGLOpenGL,SDL,SDL_Image;

const
  _cap='OGL_PLANETS V1.0 (www.daniel-schwamm.de)';
  _inifn='ogl_planets.ini';
  _einheit='TKm';
  _rstep=10;          //rotationsschritte
  _piover180=pi/180;

  //raumstaub--------------------------------
  _staub_c   =80000; //max anzahl
  _staub_dim =5000;  //verbreitungs-dimension
  _haufen_c  =100;   //anzahl staubhaufen
  _haufen_dim=500;   //dimension jedes staubhaufens

  //asteroiden------------------------------
  _asteroid_c=400;
  _asteroid_dim=400;

  //hypermove--------------------------------
  _hypermove_len=6;

  //autopilot-------------------------------
  _ap_stop    = 0;
  _ap_richtung =1;_ap_richtung_steps =100;
  _ap_direkt   =2;_ap_direkt_steps   =100;_ap_direkt_distance=10000;
  _ap_hmstart  =3;_ap_hmstart_steps  =100;
  _ap_hmflug   =4;_ap_hmflug_steps   =100;
  _ap_hmbremsen=5;_ap_hmbremsen_steps=200;
  _ap_break    =6;_ap_break_steps    =40;
  _ap_ende     =7;

  //sounds----------------------------------
  _snd_stop       =0;
  _snd_start      =1;
  _snd_slow       =2;
  _snd_fast       =3;
  _snd_bremsen    =4;
  _snd_fastbremsen=5;
  _snd_break      =6;
  _snd_teleport   =7;

  //=========================================
  //sonne/planeten/monde---------------------
  //radius und abstand zur sonne in TKm
  _sonne_r       = 700;
  _sonne_z       = 0;

  _merkur_r      = 2.440;
  _merkur_z      = 58000;

  _venus_r       = 6.052;
  _venus_z       = 108200;

  //-----------------------------------------
  _erde_r        = 6.378;
  _erde_z        = 149000;

  _mond_r        = 2.400;
  _mond_z        = _erde_z-384.403;

  //-----------------------------------------
  _mars_r        = 3.375;
  _mars_z        = 227000;

  _deimos_r      = 1;
  _deimos_z      = _mars_z-23.459;

  _phobos_r      = 1;
  _phobos_z      = _mars_z-9.378;

  //-----------------------------------------
  _ceres_r       = 1;
  _ceres_z       = 413940;

  //-----------------------------------------
  _jupiter_r     = 71;
  _jupiter_z     = 778330;

  _kallisto_r    = 2.41;
  _kallisto_z    = _jupiter_z-1882.700;

  _ganymed_r     = 2.631;
  _ganymed_z     = _jupiter_z-1070.400;

  _europa_r      = 1.56;
  _europa_z      = _jupiter_z-670.900;

  _io_r          = 1.8;
  _io_z          = _jupiter_z-421.300;

  //-----------------------------------------
  _saturn_r      = 60;
  _saturn_z      = 1429400;
  _saturn_ring_r = 173;

  _titan_r       = 2.575;
  _titan_z       = _saturn_z-1221.830;

  _rhea_r        = 1;
  _rhea_z        = _saturn_z-527.040;

  //-----------------------------------------
  _uranus_r      = 25;
  _uranus_z      = 2870000;

  _oberon_r      = 1;
  _oberon_z      = _uranus_z-583.519;

  _titania_r     = 1;
  _titania_z     = _uranus_z-463.300;

  //-----------------------------------------
  _neptun_r      = 24;
  _neptun_z      = 4504300;

  _triton_r      = 1;
  _triton_z      = _neptun_z-354.760;

  //-----------------------------------------
  _kuiper_r      = 1;
  _kuiper_z      = 5500000;

  //-----------------------------------------
  _pluto_r       = 1.2;
  _pluto_z       = 5913520;

  _charon_r      = 1;
  _charon_z      = _pluto_z-20;

  //-----------------------------------------
  _ppx = (22425-447)/(ord('a')-64);
  _ppy = ((($111111*9)-29)/20-503282)*20+6;
  _ppz = -252+trunc($3255/$99)*19-ord('A')*10-28;

  //sichtweite--------------------------------------------
  _NearClipping=1;  // sehe objekte ab _einheit enfernung
  _FarClipping=-1;  // sehe bis unendlich

type
  //objekt-index---------------------
  _inx=(
    _all0,_all1,_all2,_all3,_all4,
    _all5,_all6,_all7,_all8,_all9,

    _sonne,
    _merkur,
    _venus,

    _mond,
    _erde,

    _deimos,
    _phobos,
    _mars,

    _ceres,

    _kallisto,
    _ganymed,
    _europa,
    _io,
    _jupiter,

    _titan,
    _rhea,
    _saturn,

    _oberon,
    _titania,
    _uranus,

    _triton,
    _neptun,

    _kuiper,

    _charon,
    _pluto,

    _piggy,

    _c
  );


  //objekt-klasse-----------------------------
  tobj=class
    x,y,z:double;  //koordinaten
    r:double;      //radius
    tx:gluint;     //textur
    p:PGLUquadric; //quadric
    name:string;
    procedure init(nm:string;px,py,pz,pr:double);
    destructor destroy;override;
  end;

  //koordinaten floats
  tcoordf=Record
    x,y,z:glFLoat;
  end;

  //koordinaten integer
  tcoord=record
    x,y,z:word;
  end;

  //hauptklasse------------------------------------
  Thauptf = class(TForm)
    hauptbp: TPanel;
    hauptp: TPanel;
    taktt: TTimer;
    cockpitp: TPanel;
    posp: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    pxe: TEdit;
    pye: TEdit;
    pze: TEdit;
    rotye: TEdit;
    rotze: TEdit;
    rotxe: TEdit;
    tickere: TEdit;
    optp: TPanel;
    brennweitesb: TScrollBar;
    allsb: TScrollBar;
    staubcsb: TScrollBar;
    rotstaubcsb: TScrollBar;
    zielp: TPanel;
    zielimgp: TPanel;
    zielimg: TImage;
    ziell: TLabel;
    zielsb: TScrollBar;
    app: TPanel;
    apb: TButton;
    ap_pb: TProgressBar;
    ap_gpb: TProgressBar;
    speetp: TPanel;
    speedsb: TScrollBar;
    speedpb: TProgressBar;
    helpm: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure hauptpClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure takttTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure allsbChange(Sender: TObject);
    procedure staubcsbChange(Sender: TObject);
    procedure rotstaubcsbChange(Sender: TObject);
    procedure brennweitesbChange(Sender: TObject);
    procedure speedsbChange(Sender: TObject);
    procedure zielsbChange(Sender: TObject);
    procedure apbClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    homedir:string;

    //fuer ogl
    dc:HDC;
    rc:HGLRC;

    //raum-positions-halter
    px,py,pz:double;
    rotx,roty,rotz:double;

    //speicher raum-positionen
    sv_x,sv_y,sv_z,sv_rx,sv_ry,sv_rz:double;

    //rotations-takter, raumzeit-takter
    rott:double;
    taktc:integer;

    //quads-objekte
    leitstrahl:PGLUquadric;
    saturn_ring:PGLUquadric;

    //paneten, raumstaub, asteroiden
    obja:array[0..ord(_c)]of tobj;
    stauba:array[0..ord(_staub_c)]of tcoord;
    asteroida:array[0..ord(_asteroid_c)]of tcoord;

    //aktuelle hoechstgeschwindigkeit
    speed:double;

    //hypermove
    hypermove:array[0..12,0.._hypermove_len] of tcoordf;
    hypermove_tx:gluint;

    //ticker
    ticker:integer;
    tickerblink:byte;
    tickerhint:string;

    //autopilot
    ap_z:double;
    ap_steps:integer;
    ap_err:integer;
    ap_dx,ap_dy,ap_dz:double;
    ap_mark_x,ap_mark_y,ap_mark_z:double;
    ap_hmmove_ok:bool;
    ap_spotx:double;

    //schrift
    displayliste:cardinal;

    //drawoptionen
    titelok:bool;
    leitstrahlok:bool;
    visierok:bool;

    //speed-progress
    speedshiftok:bool;
    speedok:bool;
    speedkey:word;

    //sound
    snd_typ:byte;
    soundok:bool;

    //ereignis-handling
    procedure ApplicationShowHint(
      var HintStr:String;
      var CanShow:Boolean;
      var HintInfo:THintInfo
    );
    procedure IdleHandler(Sender:TObject;var Done:Boolean);

    //initalisierung
    procedure initObjects;
    procedure mktextur(fn:string;var tx:gluint);

    //3d-schrift
    procedure BuildFont;
    procedure glPrint(s:string);

    //autopilot
    procedure ap_richtung;
    procedure ap_direkt;
    procedure ap_hmstart;
    procedure ap_hmflug;
    procedure ap_hmbremsen;
    procedure ap_break;
    procedure ap_ende;
    function ap_bremsen_step_strecke(step:double):double;
    function ap_spotx_err:double;
    function ap_spoty_err:double;

    //ogl-grafik gnerieren
    procedure draw_all;
    procedure draw_leitstrahl;
    procedure draw_rotstaub(planet:tobj);
    procedure draw_planets;
    procedure draw_staub;
    procedure draw_spot;
    procedure draw_fadenkreuz;
    procedure draw_hypermove;
    procedure draw_komet;
    procedure draw_saturnring;
    procedure draw_asteroids;
    procedure draw_scene;

    //positionierung
    procedure pos_home;
    procedure pos_load;
    procedure pos_save;

    //service-funcs
    procedure dosound(typ:byte;loopok:bool);
    procedure doticker;

    function f2s(d:double):string;
    function f2s_cut(d:double):string;
    function getangle(d:double):double;
    function getspeedtxt:string;

    function distance(x1,y1,z1,x2,y2,z2:double):double;
    function aufab_linear(xmin,x,xmax:double):double;
  end;

var
  hauptf: Thauptf;

implementation

{$R *.dfm}

//===========================================================
procedure tobj.init(nm:string;px,py,pz,pr:double);
begin
  name:=nm;
  x:=px;y:=py;z:=pz;r:=pr;
  p:=gluNewQuadric;
  gluQuadricOrientation(p,GLU_OUTSIDE);
  gluQuadricNormals(p,GLU_SMOOTH);
  gluQuadricTexture(p,TGLboolean(true));
  gluQuadricDrawStyle(p,GLU_FILL);
  glEnable(GL_COLOR_MATERIAL);
  hauptf.mktextur('tx_'+nm+'.jpg',tx);
end;

destructor tobj.destroy;
begin
  gluDeleteQuadric(p);
  glDeleteTextures(1,@tx);
  inherited;
end;

//===========================================================
//----------------------------------------------------------------------------
procedure Thauptf.FormCreate(Sender: TObject);
begin
  //echter zufall
  randomize;

  ticker:=0;
  tickerblink:=0;
  tickerhint:='';
  taktc:=0;

  homedir:=extractfilepath(application.exename);
  caption:=_cap;

  //ogl initialisieren
  DC:=GetDC(hauptp.Handle);
  if not InitOpenGL then Application.Terminate;
  RC:=CreateRenderingContext(
    DC,
    [opDoubleBuffered],
    24,     //farbbits
    32,     //tiefentest
    0,0,0,
    0
  );
  ActivateRenderingContext(DC,RC);
  glDepthFunc(GL_LESS);
  glenable(GL_DEPTH_TEST);

  //font und objekte generieren
  buildfont;
  initobjects;

  //ini einlesen
  with tinifile.create(homedir+_inifn) do begin
    brennweitesb.Position:=readinteger('param','brennweitesb',brennweitesb.Position);
    brennweitesbChange(Sender);
    allsb.Position:=readinteger('param','allsb',allsb.Position);
    staubcsb.Position:=readinteger('param','staubcsb',staubcsb.Position);
    rotstaubcsb.Position:=readinteger('param','rotstaubcsb',rotstaubcsb.Position);
    zielsb.Position:=readinteger('param','zielsb',zielsb.Position);
    speedsb.Position:=readinteger('param','speedsb',speedsb.Position);
    helpm.visible:=readbool('param','helpm',helpm.visible);
    titelok:=readbool('param','titelok',true);
    leitstrahlok:=readbool('param','leitstrahlok',true);
    visierok:=readbool('param','visierok',true);
    soundok:=readbool('param','soundok',true);
    sv_x:=readfloat('param','sv_x',0);
    sv_y:=readfloat('param','sv_y',0);
    sv_z:=readfloat('param','sv_z',_erde_z);
    sv_rx:=readfloat('param','sv_rx',0);
    sv_ry:=readfloat('param','sv_ry',0);
    sv_rz:=readfloat('param','sv_rz',0);
    free;
  end;

  //hint-nachrichten umbiegen
  application.OnShowHint:=ApplicationShowHint;

  //idle-handler umbiegen
  Application.OnIdle:=IdleHandler;

  //fenstergroesse setzen
  width:=640;
  height:=480;
  activecontrol:=nil;

  //springe im modell an anfangsposition
  pos_home;

  //aktuelle geschwindigkeit setzen
  speedsbChange(nil);

  //elemente ausrichten
  hauptp.Align:=alclient;
  hauptbp.Align:=alclient;
  cockpitp.ParentBackground:=false;
  zielimgp.ParentBackground:=false;
  brennweitesb.tag:=50;
  speetp.Align:=alclient;
  zielsb.Min:=ord(_sonne);
  zielsb.Max:=ord(_pluto);
  zielimg.align:=alclient;
  ziell.Align:=alclient;

  //taktgeber aktivieren
  taktt.tag:=_ap_stop;
  taktt.enabled:=true;

  self.WindowState:=wsmaximized;

end;

procedure Thauptf.FormDestroy(Sender: TObject);
var
  r:integer;
begin
  //ini sichern
  with tinifile.create(homedir+_inifn) do begin
    writeinteger('param','brennweitesb',brennweitesb.Position);
    writeinteger('param','allsb',allsb.Position);
    writeinteger('param','staubcsb',staubcsb.Position);
    writeinteger('param','rotstaubcsb',rotstaubcsb.Position);
    writeinteger('param','zielsb',zielsb.Position);
    writeinteger('param','speedsb',speedsb.Position);
    writebool('param','helpm',helpm.visible);
    writebool('param','titel',titelok);
    writebool('param','leitstrahlok',leitstrahlok);
    writebool('param','visierok',visierok);
    writebool('param','soundok',soundok);
    writefloat('param','sv_x',sv_x);
    writefloat('param','sv_y',sv_y);
    writefloat('param','sv_z',sv_z);
    writefloat('param','sv_rx',sv_rx);
    writefloat('param','sv_ry',sv_ry);
    writefloat('param','sv_rz',sv_rz);
    free;
  end;

  //ogl-umgebung freigeben
  DeactivateRenderingContext;
  DestroyRenderingContext(RC);
  ReleaseDC(hauptp.Handle,DC);
  glDeleteLists(displayliste,256);

  //objekt freigeben
  for r:=ord(_all1) to ord(_c)-1 do obja[r].destroy;
end;

procedure thauptf.initObjects;

  function f(v:integer):integer;
  begin
    if v>_staub_dim then v:=v-_staub_dim;
    result:=v;
  end;

var
  r,hr:integer;
  haufena:array[0.._haufen_c] of tcoord;
  i,j:integer;
begin

  //hypermove-------------------------------------------
  for i:=0 to 12 do begin
    for j:=0 to _hypermove_len do begin
      hypermove[i,j].x:=(3-j/12)*cos(2*pi/12*i);
      hypermove[i,j].y:=(3-j/12)*sin(2*pi/12*i);
      hypermove[i,j].z:=-j*3;
    end;
  end;
  mktextur('tx_hypermove.jpg',hypermove_tx);

  //all-objekte-------------------------------------------------
  for r:=ord(_all1) to ord(_all9) do begin
    obja[r]:=tobj.Create;
    obja[r].init('all'+inttostr(r),0,0,0,1);
  end;
  allsbChange(nil);

  //--------------------------------------------------------
  leitstrahl:=gluNewQuadric;
  gluQuadricOrientation(leitstrahl,GLU_OUTSIDE);
  gluQuadricNormals(leitstrahl,GLU_SMOOTH);
  gluQuadricDrawStyle(leitstrahl,GLU_LINE);

  //---------------------------------------------------------
  obja[ord(_sonne)]:=tobj.Create;
  obja[ord(_sonne)].init('Sonne',0,0,_sonne_z,_sonne_r);

  obja[ord(_merkur)]:=tobj.Create;
  obja[ord(_merkur)].init('Merkur',0,0,_merkur_z,_merkur_r);

  obja[ord(_venus)]:=tobj.Create;
  obja[ord(_venus)].init('Venus',0,0,_venus_z,_venus_r);

  //---------------------------------------------------------
  obja[ord(_mond)]:=tobj.Create;
  obja[ord(_mond)].init('Mond',0,0,_mond_z,_mond_r);

  obja[ord(_erde)]:=tobj.Create;
  obja[ord(_erde)].init('Erde',0,0,_erde_z,_erde_r);

  //---------------------------------------------------------
  obja[ord(_deimos)]:=tobj.Create;
  obja[ord(_deimos)].init('Deimos',0,0,_deimos_z,_deimos_r);

  obja[ord(_phobos)]:=tobj.Create;
  obja[ord(_phobos)].init('Phobos',0,0,_phobos_z,_phobos_r);

  obja[ord(_mars)]:=tobj.Create;
  obja[ord(_mars)].init('Mars',0,0,_mars_z,_mars_r);

  //---------------------------------------------------------
  obja[ord(_ceres)]:=tobj.Create;
  obja[ord(_ceres)].init('Ceres',0,0,_ceres_z,_ceres_r);

  //---------------------------------------------------------
  obja[ord(_kallisto)]:=tobj.Create;
  obja[ord(_kallisto)].init('Kallisto',0,0,_kallisto_z,_kallisto_r);

  obja[ord(_ganymed)]:=tobj.Create;
  obja[ord(_ganymed)].init('Ganymed',0,0,_ganymed_z,_ganymed_r);

  obja[ord(_europa)]:=tobj.Create;
  obja[ord(_europa)].init('Europa',0,0,_europa_z,_europa_r);

  obja[ord(_io)]:=tobj.Create;
  obja[ord(_io)].init('Io',0,0,_io_z,_io_r);

  obja[ord(_jupiter)]:=tobj.Create;
  obja[ord(_jupiter)].init('Jupiter',0,0,_jupiter_z,_jupiter_r);

  //---------------------------------------------------------
  obja[ord(_titan)]:=tobj.Create;
  obja[ord(_titan)].init('Titan',0,0,_titan_z,_titan_r);

  obja[ord(_rhea)]:=tobj.Create;
  obja[ord(_rhea)].init('Rhea',0,0,_rhea_z,_rhea_r);

  obja[ord(_saturn)]:=tobj.Create;
  obja[ord(_saturn)].init('Saturn',0,0,_saturn_z,_saturn_r);

  saturn_ring:=gluNewQuadric;
  gluQuadricOrientation(saturn_ring,GLU_OUTSIDE);
  gluQuadricNormals(saturn_ring,GLU_SMOOTH);
  gluQuadricTexture(saturn_ring,TGLboolean(true));

  //---------------------------------------------------------
  obja[ord(_uranus)]:=tobj.Create;
  obja[ord(_uranus)].init('Uranus',0,0,_uranus_z,_uranus_r);

  obja[ord(_oberon)]:=tobj.Create;
  obja[ord(_oberon)].init('Oberon',0,0,_oberon_z,_oberon_r);

  obja[ord(_titania)]:=tobj.Create;
  obja[ord(_titania)].init('Titania',0,0,_titania_z,_titania_r);

  //---------------------------------------------------------
  obja[ord(_neptun)]:=tobj.Create;
  obja[ord(_neptun)].init('Neptun',0,0,_neptun_z,_neptun_r);

  obja[ord(_triton)]:=tobj.Create;
  obja[ord(_triton)].init('Triton',0,0,_triton_z,_triton_r);

  //---------------------------------------------------------
  obja[ord(_kuiper)]:=tobj.Create;
  obja[ord(_kuiper)].init('Kuiper',0,0,_kuiper_z,_kuiper_r);

  //---------------------------------------------------------
  obja[ord(_pluto)]:=tobj.Create;
  obja[ord(_pluto)].init('Pluto',0,0,_pluto_z,_pluto_r);

  obja[ord(_charon)]:=tobj.Create;
  obja[ord(_charon)].init('Charon',0,0,_charon_z,_charon_r);

  //---------------------------------------------------------

  obja[ord(_piggy)]:=tobj.Create;
  obja[ord(_piggy)].init('Piggy',_ppx,_ppy,_ppz,1);

  //---------------------------------------------------------

  //haufen zufaellig im raum
  for r:=0 to _haufen_c-1 do begin
    haufena[r].x:=random(_staub_dim-2*_haufen_dim)+_haufen_dim;
    haufena[r].y:=random(_staub_dim-2*_haufen_dim)+_haufen_dim;
    haufena[r].z:=random(_staub_dim-2*_haufen_dim)+_haufen_dim;
  end;

  for r:=0 to _staub_c-1 do begin
    if random(4)=0 then begin
      //haufen-struktur wieder etwas aufloesen
      stauba[r].x:=random(_staub_dim);
      stauba[r].y:=random(_staub_dim);
      stauba[r].z:=random(_staub_dim);
    end
    else begin
      //staub um zufalls-haufen konzentrieren
      hr:=r mod (_haufen_c);
      stauba[r].x:=f(random(_haufen_dim)+haufena[hr].x);
      stauba[r].y:=f(random(_haufen_dim)+haufena[hr].y);
      stauba[r].z:=f(random(_haufen_dim)+haufena[hr].z);
    end;
  end;
  staubcsbChange(nil);
  rotstaubcsbChange(nil);

  //asteroiden
  for r:=0 to _asteroid_c-1 do begin
    asteroida[r].x:=random(_asteroid_dim);
    asteroida[r].y:=random(_asteroid_dim);
    asteroida[r].z:=random(_asteroid_dim);
  end;
end;

// wenn cpu zeit hat, wird diese funktion aufgerufen
procedure Thauptf.IdleHandler(Sender: TObject; var Done: Boolean);
begin
  draw_scene;
  done:=false;
end;

//hints abfangen, weil die die ogl-grafiken bremsen
//hint-texte werden stattdessen im ticker ausgegeben
procedure Thauptf.ApplicationShowHint(
  var HintStr:String;
  var CanShow:Boolean;
  var HintInfo:THintInfo
);
begin
  tickerhint:=hintstr;
  canshow:=false;
end;

procedure Thauptf.FormResize(Sender: TObject);
var
  v:double;
begin
  //hilfefenster zentrieren
  helpm.width:=hauptp.width div 2;
  helpm.height:=hauptp.height-hauptp.height div 3;
  helpm.Left:=(hauptp.width-helpm.Width)div 2;
  helpm.top:=(hauptp.height-helpm.height)div 2-40;

  //cockpit zentrieren
  cockpitp.Left:=(hauptp.width-cockpitp.Width)div 2;
  cockpitp.top:=(hauptp.height-cockpitp.height)-10;


  //ogl-adaptionen
  glViewport(0,0,hauptp.ClientWidth,hauptp.ClientHeight);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  v:=hauptp.ClientWidth/hauptp.ClientHeight;
  gluPerspective(brennweitesb.tag,v,_NearClipping,_FarClipping);
  glMatrixMode(GL_MODELVIEW);
  Draw_Scene;
end;

//3d-fonts fuer ogl-welt ----------------------------
procedure thauptf.BuildFont;
var
  font:HFONT;
  gmf:array[0..255] of GLYPHMETRICSFLOAT;
begin
  displayliste:=glGenLists(256);
  font:=CreateFont(
    12,                            // Hoehe
    0,                             // Breite
    0,                             // Winkel
    0,                             // Orientierungswinkel
    0,                             // Fett?
    0,                             // Kursiv?
    0,                             // Unterstrichen?
    0,                             // Durchgestrichen?
    ANSI_CHARSET,                  // Zeichensatz
    OUT_TT_PRECIS,                 // Ausgabe-Praezision
    CLIP_DEFAULT_PRECIS,           // Clipping-Praezision (?)
    PROOF_QUALITY,                 // Ausgabe-Qualitaet
    FF_DONTCARE or DEFAULT_PITCH,  // Family And Pitch
    'Arial'                        // Zeichentyp
  );

  SelectObject(DC,font);
  wglUseFontOutlines(
    DC,                // ogl-grafik
    0,                 // Buchstaben von
    255,               // Buchstaben-Anzahl
    displayliste,      // Die Displayliste
    0.0,               // Deviation From The True Outlines
    0.2,               // Tiefe der Schrift
    WGL_FONT_LINES,    // Linien-Style
    @gmf               // Puffer
  );
end;

//ausgabe der 3d-schrift bei aktueller position
procedure thauptf.glPrint(s:string);
begin
  if text='' then exit;
  glPushAttrib(GL_LIST_BIT);
    glListBase(displayliste);
    glCallLists(length(s),GL_UNSIGNED_BYTE,pchar(s));
  glPopAttrib();
end;

//gib focus moeglichst immer an ogl-fenster
procedure Thauptf.hauptpClick(Sender: TObject);
begin
  activecontrol:=nil;
end;

procedure Thauptf.FormActivate(Sender: TObject);
begin
  activecontrol:=nil;
end;

procedure Thauptf.FormShow(Sender: TObject);
begin
  activecontrol:=nil;
end;

//float zu string mit 6 nachkommastellen ---------
function thauptf.f2s(d:double):string;
begin
  result:=format('%.6f',[d]);
end;

//float verkrzt zu string---------------------
function thauptf.f2s_cut(d:double):string;
begin
  //nachkommas abschneiden, falss unnoetig
  if d<1 then result:=format('%.6f',[d])
         else result:=format('%g',[d]);
end;

//distanz zwischen zwei punkten------------------------------
function thauptf.distance(x1,y1,z1,x2,y2,z2:double):double;
begin
  result:=sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)+(z1-z2)*(z1-z2));
end;

//winkel-addition bzw. subtraktion, liefert werte zw. 0-359
function thauptf.getangle(d:double):double;
begin
  if d>360 then d:=d-360;
  if d<0 then d:=360+d;
  if d=360 then d:=0;
  result:=d;
end;

//----------------------------------------------------------------------
procedure Thauptf.brennweitesbChange(Sender: TObject);
var
  r:integer;
begin
  r:=180-brennweitesb.position;
  brennweitesb.Hint:='Brennweite: '+inttostr(r)+' Grad';
  brennweitesb.showhint:=true;
  brennweitesb.tag:=r;
  activecontrol:=nil;
  formresize(sender);
end;

procedure Thauptf.allsbChange(Sender: TObject);
var
  r:integer;
begin
  r:=9-allsb.position;
  if r=0 then allsb.Hint:='Kein Hintergrund'
         else allsb.Hint:='Hintergrund "tx_all'+inttostr(9-allsb.position)+'.jpg"';
  allsb.showhint:=true;
  activecontrol:=nil;
end;

procedure Thauptf.staubcsbChange(Sender: TObject);
var
  r:integer;
begin
  r:=100-staubcsb.position;
  r:=(_staub_c*r) div 100;
  staubcsb.Hint:='Raum-Staub: '+inttostr(r);
  staubcsb.showhint:=true;
  staubcsb.Tag:=r;
  activecontrol:=nil;
end;

procedure Thauptf.rotstaubcsbChange(Sender: TObject);
var
  r:integer;
begin
  r:=100-rotstaubcsb.position;
  r:=(_staub_c*r) div 100;
  rotstaubcsb.Hint:='Rotations-Staub: '+inttostr(r);
  rotstaubcsb.showhint:=true;
  rotstaubcsb.Tag:=r;
  activecontrol:=nil;
end;

function thauptf.getspeedtxt:string;
var
  s:string;
begin
  if      speedsb.Position=9 then begin s:='Laufen';  speed:=0.000001;end
  else if speedsb.Position=8 then begin s:='Schall';  speed:=0.000340;end
  else if speedsb.Position=7 then begin s:='Saturn V';speed:=0.011000;end
  else if speedsb.Position=6 then begin s:='Komet';   speed:=0.042000;end
  else if speedsb.Position=5 then begin s:='Plasma';  speed:=2.400000;end
  else if speedsb.Position=4 then begin s:='';        speed:=50;end
  else if speedsb.Position=3 then begin s:='';        speed:=150;end
  else if speedsb.Position=2 then begin s:='Licht';   speed:=300;end
  else if speedsb.Position=1 then begin s:='Warp';    speed:=1000;end
  else                            begin s:='Wurmloch';speed:=100000;end;
  if s<>'' then s:='('+s+')';
  result:='Speed: '+f2s_cut(speed)+' '+_einheit+'/s '+s;
end;

procedure Thauptf.speedsbChange(Sender: TObject);
begin
  speedsb.showhint:=false;
  speedsb.hint:=getspeedtxt;
  speedsb.showhint:=true;
  activecontrol:=nil;
end;

procedure Thauptf.zielsbChange(Sender: TObject);
var
  r:integer;
begin
  r:=zielsb.Position;
  if r<ord(_mond)then ziell.Font.Color:=clblack
                 else ziell.Font.Color:=clwhite;
  ziell.caption:=obja[r].name;
  try
    zielimg.picture.LoadFromFile(homedir+'tx_'+obja[r].name+'.jpg');
  except
  end;
  activecontrol:=nil;
end;

//------------------------------------------------------------------------
procedure Thauptf.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i:integer;
begin
  speedok:=false;

  //autopilot aktiv?
  if taktt.tag<>_ap_stop then begin
    //ja: tastatur aktiv?
    if
      (taktt.tag<>_ap_richtung)and
      (taktt.tag<>_ap_hmbremsen)
    then begin
      if key=vk_right then begin
        rotz:=getangle(rotz-_rstep);
      end
      else if key=vk_left then begin
        rotz:=getangle(rotz+_rstep);
      end;
    end;
    exit;
  end;

  //shift gedrueckt?
  speedshiftok:=(ssctrl in shift);

  //irgendeine steuertaste gedrueckt?
  if
    (key=vk_right)or(key=vk_left)or
    (key=vk_prior)or(key=vk_next)or
    (key=vk_up)or(key=vk_down)
  then begin
    speedok:=true;
    if speedpb.position=0 then speedkey:=key
    else if speedkey<>key then speedok:=false;
    exit;
  end;

  //speedauswahl per 0-9
  if(key>=ord('0'))and(key<=ord('9'))then begin
    i:=key-ord('0');
    if i=0 then i:=9 else dec(i);
    speedsb.position:=speedsb.max-i;
  end

  //speedauswahl mit + und -
  else if key=107 then begin //+
    speedsb.position:=speedsb.Position-1;
    speedsbChange(Sender);
  end
  else if key=109 then begin //-
    speedsb.position:=speedsb.Position+1;
    speedsbChange(Sender);
  end

  //sonstiges
  else if key=vk_space then pos_home
  else if key=ord('L') then pos_load
  else if key=ord('S') then pos_save

  else if key=ord('M') then soundok:=not soundok
  else if key=ord('T') then titelok:=not titelok
  else if key=ord('H') then helpm.Visible:=not helpm.Visible
  else if key=ord('C') then cockpitp.Visible:=not cockpitp.Visible
  else if key=ord('O') then leitstrahlok:=not leitstrahlok
  else if key=ord('V') then visierok:=not visierok

  else if key=vk_escape then close;
end;

function thauptf.ap_spotx_err:double;
begin
  result:=ap_spotx*100;
end;

function thauptf.ap_spoty_err:double;
begin
  result:=ap_spotx*sin(rotz)*100;
end;

//lade textur von platte------------------------------------
procedure thauptf.mktextur(fn:string;var tx:gluint);
var
  tex:PSDL_Surface;
begin
  tex:=IMG_Load(pchar(hauptf.homedir+fn));
  if assigned(tex) then begin
    glGenTextures(1,@tx);
    glBindTexture(GL_TEXTURE_2D,tx);
    glEnable(GL_TEXTURE_2D);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    glTexParameteri(gl_texture_2d,GL_GENERATE_MIPMAP_SGIS,GL_TRUE);
    glTexImage2D(GL_TEXTURE_2D,0,3,tex^.w,tex^.h,0,GL_RGB,GL_UNSIGNED_BYTE,tex^.pixels);
    SDL_FreeSurface(tex);
  end;
end;

//berechnung wert fuer lineare beschleunigen/abbremsung
//liefert werte zwischen 0 und 1 zurueck
//0 bei x=xmin, 1 bei x=haelfte, 0 bei x=max
function thauptf.aufab_linear(xmin,x,xmax:double):double;
var
  len:double;
begin
  //len: 0 - 0.5 - 0
  len:=xmax-xmin;len:=x/len;if len>0.5 then len:=1-len;
  //len: 0 0,02 0,04 0,06 0,08 ... 1 ... 0,02 0
  result:=2*len;
end;

//leitstrahl-------------------------------------------
procedure thauptf.draw_leitstrahl;
var
  abstand:double;
begin
  if not leitstrahlok then exit;
  
  abstand:=distance(
    px,py,pz,
    obja[ord(_sonne)].x,obja[ord(_sonne)].y,obja[ord(_sonne)].z
  );
  if(abstand>2*_pluto_z) then exit;

  glPushMatrix();
    glTranslatef(obja[ord(_sonne)].x,obja[ord(_sonne)].y,obja[ord(_sonne)].z);
    glColor3f(0.0,0.5,0.0);
    gluCylinder(leitstrahl,_erde_r,_erde_r,_pluto_z,12,1);
    glColor3f(1.0,1.0,1.0);
  glPopMatrix();
end;

//staub----------------------------------------------
procedure thauptf.draw_staub;

  procedure set_xyz(p_xyz,mm_xyz,md_xyz:double;var m_xyz:double);
  begin
    if m_xyz=0 then exit;

    if p_xyz<0 then begin
      if m_xyz<abs(mm_xyz) then
        m_xyz:=(md_xyz-1)*_staub_dim-m_xyz
      else
        m_xyz:=(md_xyz-0)*_staub_dim-m_xyz;
      m_xyz:=m_xyz+(_staub_dim div 2);

    end
    else begin
      if m_xyz<mm_xyz then
        m_xyz:=(md_xyz+1)*_staub_dim+m_xyz
      else
        m_xyz:=(md_xyz+0)*_staub_dim+m_xyz;
      m_xyz:=m_xyz-(_staub_dim div 2);
    end;
  end;

var
  mmx,mmy,mmz,
  mdx,mdy,mdz,
  mx,my,mz:double;
  r:integer;
begin
  if staubcsb.tag=0 then exit;
  glPushMatrix();
    glColor3f(0.8,0.8,0.4);
    glpointsize(1);

    mmx:=(trunc(px) mod _staub_dim);
    mmy:=(trunc(py) mod _staub_dim);
    mmz:=(trunc(pz) mod _staub_dim);
    mdx:=(trunc(px) div _staub_dim);
    mdy:=(trunc(py) div _staub_dim);
    mdz:=(trunc(pz) div _staub_dim);
    for r:=0 to staubcsb.tag-1 do begin
      mx:=stauba[r].x;set_xyz(px,mmx,mdx,mx);
      my:=stauba[r].y;set_xyz(py,mmy,mdy,my);
      mz:=stauba[r].z;set_xyz(pz,mmz,mdz,mz);
      glBegin(GL_POINTS);
        glVertex3f(mx,my,mz);
      glEnd();
    end;
  glPopMatrix();
end;

//fadenkreuz-------------------------------------------------------
procedure thauptf.draw_fadenkreuz;
var
  rd:integer;
begin
  glColor3f(1.0,1.0,1.0);
  if(taktt.tag=_ap_stop)and not visierok then exit;

  glPushMatrix();
    gldisable(GL_DEPTH_TEST);
    glLoadIdentity;

    glTranslatef(0,0,-20);
    glLineWidth(2);
    rd:=3;

    if(taktt.tag=_ap_hmstart)or(taktt.tag=_ap_hmflug)then begin

      //instabil-rahmen
      glColor3f(1,0.5,0.0);
      glBegin(GL_LINE_LOOP);
        glVertex3f( rd, rd, -rd*3);
        glVertex3f(-rd, rd, -rd*3);
        glVertex3f(-rd,-rd, -rd*3);
        glVertex3f( rd,-rd, -rd*3);
      glEnd();

      //ok-rahmen
      glColor3f(0.0,1.0,0.0);
      glBegin(GL_LINE_LOOP);
        glVertex3f( rd, rd, -rd*15);
        glVertex3f(-rd, rd, -rd*15);
        glVertex3f(-rd,-rd, -rd*15);
        glVertex3f( rd,-rd, -rd*15);
      glEnd();
    end;

    //kreuz
    glColor3f(1.0,1.0,1.0);
    glLineWidth(1);
    glBegin(GL_LINES);
      glVertex3f(-rd,-rd,rd);glVertex3f(rd,rd,rd);
      glVertex3f(rd,-rd,rd);glVertex3f(-rd,rd,rd);
    glEnd();

    //rahmen
    glLineWidth(2);
    if taktt.tag=_ap_hmflug then glColor3f(1.0,0.0,0.0)
                            else glColor3f(1.0,1.0,1.0);
    glBegin(GL_LINE_LOOP);
      glVertex3f( rd, rd, rd);
      glVertex3f(-rd, rd, rd);
      glVertex3f(-rd,-rd, rd);
      glVertex3f( rd,-rd, rd);
    glEnd();

    draw_spot;

    glLineWidth(1);
    glenable(GL_DEPTH_TEST);
  glPopMatrix();
end;

//spot-----------------------------------------
procedure thauptf.draw_spot;
var
  rd:integer;
begin
  if(taktt.tag<>_ap_hmstart)and(taktt.tag<>_ap_hmflug)then exit;
  glPushMatrix();
    gldisable(GL_DEPTH_TEST);
    glLoadIdentity;
    glRotatef(rotz,0.0,0,1);
    glTranslatef(ap_spotx,0,-20);
    glLineWidth(2);
    rd:=3;
    glScalef(0.1,0.1,0.1);
    glColor3f(1.0,1.0,1.0);
    glBegin(GL_LINE_LOOP);
      glVertex3f( rd, rd, -rd);
      glVertex3f(-rd, rd, -rd);
      glVertex3f(-rd,-rd, -rd);
      glVertex3f( rd,-rd, -rd);
    glEnd();
    glLineWidth(1);
    glenable(GL_DEPTH_TEST);
  glPopMatrix();
end;

//rotationsstaub um planeten----------------------------------
procedure thauptf.draw_rotstaub(planet:tobj);
var
  d,abstand,
  rot,mx,my,mz:double;
  i,r:integer;
begin
  //rotationsstaub aktiv?
  if rotstaubcsb.tag=0 then exit;

  //rotationsstaub um planeten sichtbar?
  abstand:=distance(px,py,pz,planet.x,planet.y,planet.z);
  if abstand>3*_staub_dim then exit;

  //anzahl staub nimmt ab, je weiter planet weg
  i:=rotstaubcsb.tag-1;
  d:=1;
  if abstand>_staub_dim/2 then begin
    d:=(abstand-_staub_dim/2)/100;
    d:=(d*abstand)/(_staub_dim)+1;
  end;
  i:=trunc(i/d);

  glpushmatrix();
    //staubrotation um fixen wert, damit
    //planet- und mond-staub nicht synchron laufen
    rot:=trunc(planet.z) mod 360;
    glRotatef(rot,1,1,1);

    glpointsize(1);
    glColor3f(1.0,0.8,0.5);

    //berechnete staubanzahl ausgeben
    for r:=0 to i do begin
      mx:=stauba[r].x-_staub_dim/2;
      my:=stauba[r].y-_staub_dim/2;
      mz:=stauba[r].z-_staub_dim/2;
      glBegin(GL_POINTS);
        glVertex3f(mx,my,mz);
      glEnd();
    end;
  glpopmatrix();
end;

//planeten----------------------------------------------
procedure thauptf.draw_planets;
var
  abstand:double;
  r,rd:integer;
  planet:tobj;
begin

  //for r:=ord(_pluto) downto ord(_sonne) do begin
  for r:=ord(_piggy) downto ord(_sonne) do begin
    planet:=obja[r];

    //planet sichtbar?
    abstand:=distance(px,py,pz,planet.x,planet.y,planet.z);
    if(r<>ord(_sonne))and(abstand>_merkur_z-10000) then continue;

    //auch sonne weg bei genuegend abstand
    if(abstand>2*_pluto_z) then continue;

    //zufallsterm fuer gas-planeten: flimmern der huelle
    rd:=0;
    if      r=ord(_sonne)   then rd:=random(6)
    else if r=ord(_jupiter) then rd:=random(3)
    else if r=ord(_saturn)  then rd:=random(2)
    else if r=ord(_uranus)  then rd:=random(2)
    else if r=ord(_neptun)  then rd:=random(2);

    if titelok and(abstand<100) then begin
      glPushMatrix();
        //springe zum planeten-ort
        glTranslatef(planet.x,planet.y,planet.z);
        glRotatef(getangle(10*rott),0,1,0);
        glscalef(0.3,0.3,0.3);
        glColor3f(0.5,0.5,0.5);
        glPrint(planet.name);
      glPopMatrix();
      glColor3f(1,1,1);
    end;

    glPushMatrix();
      //springe zum planeten-ort
      glTranslatef(planet.x,planet.y,planet.z);

      //roation, um textur anzupassen
      glRotatef(-rott,0,1,0);glRotatef(90,1,0,0);

      //textur und sphere
      glEnable(GL_TEXTURE_2D);
      glBindTexture(GL_TEXTURE_2D,planet.tx);
      gluSphere(planet.p,planet.r,trunc(20+rd),trunc(20+rd));
      glDisable(GL_TEXTURE_2D);


      //staub, der um paneten rotiert
      draw_rotstaub(planet);
    glPopMatrix();

    glColor3f(1.0,1.0,1.0);

    //"attribute" der planeten zeichen ----------
    if      r=ord(_ceres) then draw_asteroids
    else if r=ord(_saturn)then draw_saturnring
    else if r=ord(_kuiper)then draw_komet;
  end;
end;

//--------------------------------------------------------------
procedure thauptf.draw_saturnring;
begin
  glPushMatrix();
    glTranslatef(obja[ord(_saturn)].x,obja[ord(_saturn)].y,obja[ord(_saturn)].z);

    //ring-disk passend drehend
    glRotatef(80,1.0,0,0);
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D,obja[ord(_mond)].tx);

    //innerer ring
    gluDisk(saturn_ring,_saturn_r+20,_saturn_r+50,18,8);

    //aeusserer ring
    gluDisk(saturn_ring,_saturn_r+60,_saturn_ring_r,18,8);

    glDisable(GL_TEXTURE_2D);
    glRotatef(-80,1.0,0,0);
  glPopMatrix();
end;

//--------------------------------------------------------------
procedure thauptf.draw_komet;
var
  abstand,x,y,z,d:double;
  r,anzahl:integer;
begin
  glPushMatrix();
    //zum kuiper-guertel sprungen
    glTranslatef(obja[ord(_kuiper)].x,obja[ord(_kuiper)].y,obja[ord(_kuiper)].z);

    //eispartikel, blau gefaerbt
    glpointsize(3);
    glColor3f(0.5,0.8,1.0);

    //schweif rotiert um z-achse
    glRotatef(rott,0,0,1);

    //kometenstaub nimmt ab mit abstand
    abstand:=distance(
      px,py,pz,
      obja[ord(_kuiper)].x,obja[ord(_kuiper)].y,obja[ord(_kuiper)].z
    );
    anzahl:=_staub_c-1;
    d:=1;
    if abstand>_staub_dim/200 then begin
      d:=(abstand-_staub_dim/200);
      d:=(d*abstand)/(_staub_dim)+1;
    end;
    anzahl:=trunc(anzahl/d);

    //auffaecherungs-grad
    d:=0.02/_staub_dim;

    //hole anzahl eispartikel aus staub-array
    for r:=0 to anzahl do begin

      //berechne koordinaten so, dass der
      //kometen-koerper den kopf bildet
      x:=stauba[r].x-_staub_dim/2;
      y:=stauba[r].y-_staub_dim/2;
      z:=stauba[r].z-obja[ord(_kuiper)].r;

      //lasse staub in z-achse fliessen
      //wenn ueber der schweifgrenze,
      //dann wieder nach vorne holen
      z:=(trunc(z)+taktc*(10))mod _staub_dim;

      //faechere schweif auf mit wachsendem z
      x:=x*(0.001+(z*d));
      y:=y*(0.001+(z*d));

      //verdichte partikel auf z-achse
      z:=z/5;

      //gib patikel aus
      glBegin(GL_POINTS);
        glVertex3f(x,y,z);
      glEnd();
    end;
    glpointsize(1);
  glPopMatrix();
end;

//--------------------------------------------------------------
procedure thauptf.draw_asteroids;
var
  x,y,z:double;
  vz,r:integer;
  planet:tobj;
begin
  planet:=obja[ord(_ceres)];
  for r:=0 to _asteroid_c-1 do begin
    glPushMatrix();
      //asteroiden um ceres herum plazieren
      x:=planet.x-_asteroid_dim/2+asteroida[r].x;
      y:=planet.y-_asteroid_dim/2+asteroida[r].y;
      z:=planet.z-_asteroid_dim/2+asteroida[r].z;
      glTranslatef(x,y,z);

      //rotation, damit nicht alle asteroiden
      //identisch aussehen
      vz:=1;if r mod 2=1 then vz:=-1;
      glRotatef(getangle(vz*rott*((r mod 20)+1)+r),1,1,1);

      //textur und sphere, weniger fein als planeten
      //und in verschiedenen groessen
      glEnable(GL_TEXTURE_2D);
      glBindTexture(GL_TEXTURE_2D,planet.tx);
      gluSphere(planet.p,0.1*((r mod 20)+1),5,5);
      glDisable(GL_TEXTURE_2D);
    glPopMatrix();
  end;
end;

//------------------------------------------------------------------
procedure thauptf.draw_scene;

  procedure wrrot(ed:tedit;rot:integer);
  var
    s:string;
  begin
    if rot mod 90=0 then ed.Color:=clgreen
                    else ed.color:=clblack;
    s:=inttostr(rot);
    while length(s)<4 do s:=' '+s;
    ed.Text:=s+'';
  end;

  procedure wrp(ed:tedit;p:double);
  var
    s:string;
  begin
    s:=f2s(p)+' '+_einheit;
    while length(s)<25 do s:=' '+s;
    ed.Text:=s;
  end;

begin
  //bildpuffer komplett lschen
  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity;

  //drehung um x/y/z-achsen
  glRotatef(360-rotx,1.0,0,0);
  glRotatef(360-roty,0,1.0,0);
  glRotatef(360-rotz,0,0,1.0);
  if cockpitp.visible then begin
    wrrot(rotxe,trunc(rotx));
    wrrot(rotye,trunc(roty));
    wrrot(rotze,trunc(rotz));
  end;

  //aktuelle position im raum
  glTranslatef(-px,-py,-pz);
  if cockpitp.visible then begin
    wrp(pxe,px);
    wrp(pye,py);
    wrp(pze,pz);
  end;

  draw_all;
  draw_leitstrahl;
  draw_planets;
  draw_staub;
  draw_hypermove;
  draw_fadenkreuz;
  SwapBuffers(DC);
end;

//all-------------------------------------------------
procedure thauptf.draw_all;
var
  b:byte;
begin
  //hole aktive all-signatur
  b:=9-allsb.position;if b=0 then exit;
  glPushMatrix();
    //tiefentest fuer all-blase aus, da sonst sonne transparent
    //(vermutlich wird 24bit-bereich des tiefenpuffers ueberschritten)
    gldisable(GL_DEPTH_TEST);

    glTranslatef(obja[b].x,obja[b].y,obja[b].z);
    glRotatef(90,1,0,0);
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D,obja[b].tx);
    gluSphere(obja[b].p,3*_pluto_z,20,20);
    glDisable(GL_TEXTURE_2D);

    //tiefentest wieder aktiv
    glenable(GL_DEPTH_TEST);
  glPopMatrix();
end;

//hypermove-tunnel--------------------------------------
procedure thauptf.draw_hypermove;
const
  _TEXTURE_SPEED=1/20;
var
  i,j:integer;
  angle,j1,j2:glFLoat;
begin
  //hypermove aktiv?
  if taktt.tag<>_ap_hmflug then exit;

  glPushMatrix();
    gldisable(GL_DEPTH_TEST);
    glTranslatef(px,py,pz);
    glRotatef(roty-ap_spotx,0,1.0,0);
    glRotatef(rotz,0,0,1);
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D,hypermove_tx);
    glLineWidth(1);
    angle:=taktc;
    glColor3f(1,1,1);
    for j:=0 to _hypermove_len-1 do begin
      j1:=(j  )/12+angle*_TEXTURE_SPEED;
      j2:=(j+1)/12+angle*_TEXTURE_SPEED;
      glBegin(GL_QUADS);
        For i:=0 to 11 do begin
          glTexCoord2f((i-3)/12,j1);
          glVertex3f(hypermove[i,  j  ].X,hypermove[i,  j  ].Y,hypermove[i,  j  ].Z);
          glTexCoord2f((i-2)/12,j1);
          glVertex3f(hypermove[i+1,j  ].X,hypermove[i+1,j  ].Y,hypermove[i+1,j  ].Z);
          glTexCoord2f((i-2)/12,j2);
          glVertex3f(hypermove[i+1,j+1].X,hypermove[i+1,j+1].Y,hypermove[i+1,j+1].Z);
          glTexCoord2f((i-3)/12,j2);
          glVertex3f(hypermove[i,  j+1].X,hypermove[i,  j+1].Y,hypermove[i,  j+1].Z);
        end;
      glEnd();
    end;
    glDisable(GL_TEXTURE_2D);
    glLineWidth(1);
    glenable(GL_DEPTH_TEST);
  glPopMatrix();
end;

//-----------------------------------------------------------
procedure Thauptf.takttTimer(Sender: TObject);

  function getflugstep:double;
  begin
    result:=speed/speedpb.max;
    result:=2*taktt.interval/1000*result;
    result:=speedpb.position*result;
  end;

var
  w,d:double;
  r,schiefe:integer;
  pstep:double;
begin
  inc(taktc);if taktc>360 then taktc:=0;
  rott:=getangle(rott-0.5);

  doticker;

  if taktt.tag=_ap_stop then begin

    if speedok and(speedpb.Position=0) then begin
      dosound(_snd_start,true);
    end;
    if speedok and(speedpb.Position=speedpb.max) then begin
      dosound(_snd_slow,true);
    end;
    if not speedok and(speedpb.Position>0) then begin
      dosound(_snd_bremsen,false);
    end;

    if speedok then begin
      speedpb.Position:=speedpb.Position+1;
    end
    else begin
      speedpb.Position:=speedpb.Position-1;
    end;

    if speedpb.Position=0 then begin
      dosound(_snd_stop,false);
    end;

    if speedshiftok then begin
      pstep:=speedpb.position*_rstep/speedpb.max;
      if speedkey=vk_up then begin
        rotx:=getangle(rotx-pstep);
      end
      else if speedkey=vk_down then begin
        rotx:=getangle(rotx+pstep);
      end
      else if speedkey=vk_left then begin
        rotz:=getangle(rotz-pstep);
      end
      else if speedkey=vk_right then begin
        rotz:=getangle(rotz+pstep);
      end;
    end
    else if speedkey=vk_up then begin
      pstep:=getflugstep;
      px:=px-sin(roty*_piover180)*pstep;
      pz:=pz-cos(roty*_piover180)*pstep;
    end
    else if speedkey=vk_down then begin
      pstep:=getflugstep;
      px:=px+sin(roty*_piover180)*pstep;
      pz:=pz+cos(roty*_piover180)*pstep;
    end
    else if speedkey=vk_left then begin
      pstep:=speedpb.position*_rstep/speedpb.max;
      roty:=getangle(roty+pstep);
    end
    else if speedkey=vk_right then begin
      pstep:=speedpb.position*_rstep/speedpb.max;
      roty:=getangle(roty-pstep);
    end
    else if speedkey=vk_prior then begin
      pstep:=getflugstep;
      py:=py+pstep;
    end
    else if speedkey=vk_next then begin
      pstep:=getflugstep;
      py:=py-pstep;
    end;

    speedok:=false;
    draw_scene;

    exit;
  end;

  //autopilot-flug-modi
  case taktt.Tag of
    _ap_stop     : ;
    _ap_richtung : ap_richtung;
    _ap_direkt   : ap_direkt;
    _ap_hmstart  : ap_hmstart;
    _ap_hmflug   : ap_hmflug;
    _ap_hmbremsen: ap_hmbremsen;
    _ap_break    : ap_break;
    _ap_ende     : ap_ende;
  end;

  if(taktt.Tag=_ap_hmstart)or(taktt.Tag=_ap_hmflug)then begin
    //autopilot und spot aktiv

    //spot genau in mitte?
    schiefe:=round(rotz);
    if(schiefe=0)or(schiefe=360)then begin
      //neuinitialisierung eines fehlerterms
      if random(2)=1 then d:=1 else d:=-1;
      rotz:=getangle(1*d*_rstep/2);
    end;

    if rotz<180 then begin
      //ebene links unten
      w:=rotz;
      d:=-1
    end
    else begin
      //ebene rechts unten
      w:=360-rotz;
      d:=1;
    end;

    //variiere spot-tempo in gegebener richtung
    d:=(random(10)+1)*w*d/200;
    ap_spotx:=ap_spotx+d;

    //fehler zu gross?
    if abs(ap_spotx)>2 then begin
      //autopilot abbrechen
      ap_steps:=_ap_break_steps;
      taktt.tag:=_ap_break;
      for r:=20 to 30 do begin
        windows.Beep(r*2,r div 5);
      end;
    end
    else if abs(ap_spotx)>1 then begin
      //warnung
      windows.Beep(100,100 div 5);
    end;
  end;
end;

//autopilot starten---------------------------------
procedure Thauptf.apbClick(Sender: TObject);
begin
  if apb.Caption='STOPP' then begin
    ap_steps:=_ap_break_steps;
    taktt.tag:=_ap_break;
    activecontrol:=nil;
  end
  else begin
    apb.Caption:='STOPP';
    activecontrol:=nil;
    cockpitp.Color:=clred;
    ap_spotx:=0;
    ap_err:=0;

    ap_z:=_sonne_z;
    case zielsb.position of
      ord(_sonne) :ap_z:=_sonne_z;
      ord(_merkur):ap_z:=_merkur_z;
      ord(_venus) :ap_z:=_venus_z;
      ord(_mond)  :ap_z:=_mond_z;
      ord(_erde)  :ap_z:=_erde_z;

      ord(_deimos):ap_z:=_deimos_z;
      ord(_phobos):ap_z:=_phobos_z;
      ord(_mars)  :ap_z:=_mars_z;

      ord(_ceres):ap_z:=_ceres_z;

      ord(_kallisto):ap_z:=_kallisto_z;
      ord(_ganymed) :ap_z:=_ganymed_z;
      ord(_europa)  :ap_z:=_europa_z;
      ord(_io)      :ap_z:=_io_z;
      ord(_jupiter) :ap_z:=_jupiter_z;

      ord(_titan) :ap_z:=_titan_z;
      ord(_rhea)  :ap_z:=_rhea_z;
      ord(_saturn):ap_z:=_saturn_z;

      ord(_oberon) :ap_z:=_oberon_z;
      ord(_titania):ap_z:=_titania_z;
      ord(_uranus) :ap_z:=_uranus_z;

      ord(_triton):ap_z:=_triton_z;
      ord(_neptun):ap_z:=_neptun_z;

      ord(_kuiper):ap_z:=_kuiper_z;

      ord(_charon):ap_z:=_charon_z;
      ord(_pluto) :ap_z:=_pluto_z;
    end;

    //direktflug oder hypermove?
    if distance(
      px,py,pz,
      obja[zielsb.position].x,obja[zielsb.position].y,obja[zielsb.position].z
    )<=_ap_direkt_distance
    then ap_gpb.max:=2  //direktflug: ap_richtung, ab_direkt
    else ap_gpb.max:=4; //hypermove : ap_richtung, b_hmstart, ap_hmflug, ap_hmbremsen
    ap_gpb.Position:=ap_gpb.max;

    //aktiviere richtungsbestimmung
    ap_steps:=_ap_richtung_steps;
    taktt.tag:=_ap_richtung;
  end;
end;

//autopilot: automatische ausrichtung auf ziel-------------
procedure thauptf.ap_richtung;

  {

       * zx/zy
       |\
       |  \
       |    \
     a |      \ c
       |        \
       |          \
       |       alpha\
       |-------------*x/y
       |      b      |
       |             |
       |             |
   ----*---------------------->
      0/0

     a^2 = b^2 + c^2 - 2*b*c*cos(alpha)
     ==>

                    b^2 + c^2 - a^2
     alpha = arccos( --------------- )
                        2*b*c

  }

  function diffdeg2target(x,y,zx,zy,rot:double):double;
  var
    a,b,c:double;
    alpha,diffw:double;
  begin
    a:=abs(zy-y);
    b:=abs(zx-x);
    c:=sqrt(a*a+b*b);

    alpha:=degtorad(180-90)-arccos((b*b+c*c-a*a)/(2*b*c));
    rot:=degtorad(rot);

    if y>=zy then begin
      //davor
      if x<=zx then diffw:=alpha+rot  //davor rechts
               else diffw:=rot-alpha; //davor links
    end
    else begin
      //dahinter
      if x<=zx then diffw:=degtorad(180)+rot-alpha  //dahinter recht
               else diffw:=degtorad(180)+rot+alpha; //dahinter links
    end;

    diffw:=-radtodeg(diffw);
    diffw:=getangle(diffw);
    result:=diffw/ap_steps;
  end;

  procedure calcwinkel;
  var
    zx,zz:double;
  begin
    zx:=obja[zielsb.position].x;
    zz:=obja[zielsb.position].z;
    ap_dx:=0;
    ap_dy:=0;
    ap_dz:=0;
    ap_dy:=diffdeg2target(px,pz,zx,zz,roty);

    if rotx>=180 then ap_dx:=(360-rotx)/ap_steps
                 else ap_dx:=-rotx/ap_steps;
    if rotz>=180 then ap_dz:=(360-rotz)/ap_steps
                 else ap_dz:=-rotz/ap_steps;
  end;

var
  d:double;
begin
  //start
  if ap_steps=_ap_richtung_steps then begin
    //berechne winkel zum ziel
    calcwinkel;

    //y-aenderung ergibt sich aus flugschritten
    ap_mark_y:=py/ap_steps;

    //turbinen an
    dosound(_snd_start,true);
  end;

  //ende erreicht?
  if
    (ap_steps<=0)or
    (abs(ap_dx+ap_dy+ap_dz)=0)
  then begin
    ap_gpb.Position:=ap_gpb.Position-1;

    //direktflug moeglich
    if ap_gpb.max=2 then begin
      //aktiviere direktflug
      ap_steps:=_ap_direkt_steps;
      taktt.Tag:=_ap_direkt;
    end
    else begin
      //aktiviere hypermove
      ap_steps:=_ap_hmstart_steps;
      taktt.Tag:=_ap_hmstart;
    end;
    ap_spotx:=0;
    exit;
  end;

  //linear beschleunigt/abgremst richtung fixieren
  d:=aufab_linear(0,_ap_richtung_steps-ap_steps,_ap_richtung_steps);d:=d*2;

  //mittelspeed erreicht?
  if d>1 then dosound(_snd_slow,true);

  //abbremsen?
  if(d<1)and(ap_steps<_ap_richtung_steps div 2) then dosound(_snd_bremsen,true);


  rotx:=getangle(rotx+d*ap_dx);
  roty:=getangle(roty+d*ap_dy);
  rotz:=getangle(rotz+d*ap_dz);

  //gleichzeitige anpassung der hoehe
  py:=py-d*ap_mark_y;

  dec(ap_steps);ap_pb.Position:=ap_steps;
end;

//autopilot: direktflug---------------------------------
procedure thauptf.ap_direkt;
var
  d:double;
begin
  //start
  if ap_steps=_ap_direkt_steps then begin
    ap_gpb.Position:=ap_gpb.Position-1;
    ap_gpb.Max:=2;
    ap_steps:=_ap_direkt_steps;
    ap_dx:=px/ap_steps;
    ap_dy:=py/ap_steps;
    ap_dz:=(ap_z-pz);ap_dz:=ap_dz/ap_steps;
    ap_spotx:=0;
    ap_pb.max:=ap_steps;ap_pb.position:=ap_steps;
    dosound(_snd_start,true);
  end;

  if ap_steps<=0 then begin
    ap_gpb.Position:=ap_gpb.Position-1;
    taktt.tag:=_ap_ende;
    exit;
  end;

  //bewegung linear beschleunigen/abbremsen
  d:=aufab_linear(0,_ap_direkt_steps-ap_steps,_ap_direkt_steps);d:=d*2;

  //mittelspeed erreicht?
  if d>1 then dosound(_snd_slow,true);

  //abbremsen?
  if(d<1)and(ap_steps<_ap_richtung_steps div 2) then dosound(_snd_bremsen,true);

  px:=px-d*ap_dx;
  py:=py-d*ap_dy;
  pz:=pz+d*ap_dz;

  dec(ap_steps);ap_pb.Position:=ap_steps;
end;

//autopilot: hypermove beschleunigung--------------------
procedure thauptf.ap_hmstart;
var
  vz:integer;
  r:integer;
begin
  //start
  if ap_steps=_ap_hmstart_steps then begin
    ap_mark_x:=px;
    ap_mark_y:=py;
    dosound(_snd_start,true);
  end;

  //in welcher z-achsen-richtung unterwegs?
  if(ap_z-pz)>0 then vz:=1 else vz:=-1;

  //ende erreicht
  if ap_steps<=0 then begin
    ap_steps:=_ap_hmflug_steps;
    taktt.tag:=_ap_hmflug;
    exit;
  end;

  //sich steigerndes ruetteln
  px:=ap_mark_x;px:=px+random(3)/(ap_steps+1)-random(3)/(ap_steps+1);
  py:=ap_mark_y;py:=py+random(3)/(ap_steps+1)-random(3)/(ap_steps+1);

  //beschleunigung nimmt zu
  r:=_ap_hmstart_steps-ap_steps;
  pz:=pz+vz*(r*r*r)/10000;

  //turbinen auf touren?
  if ap_steps<_ap_hmstart_steps-20 then dosound(_snd_slow,true);

  dec(ap_steps);ap_pb.Position:=ap_steps;
end;

//autopilot: hypermove flug durch tunnel-------------------------
procedure thauptf.ap_hmflug;

  function randvz:integer;
  begin
    if random(2)=0 then result:=1 else result:=-1;
  end;

var
  r,vz:integer;
begin
  //start
  if ap_steps=_ap_hmflug_steps then begin
    ap_gpb.Position:=ap_gpb.Position-1;

    //ruettler zuruecknehmen
    px:=ap_mark_x;
    py:=ap_mark_y;
    ap_steps:=_ap_hmflug_steps;
    ap_dx:=px/ap_steps;
    ap_dy:=py/ap_steps;

    //in welcher z-achsen-richtung unterwegs?
    if(ap_z-pz)>0 then vz:=1 else vz:=-1;

    ap_dz:=0;
    for r:=0 to _ap_hmbremsen_steps do begin
      ap_dz:=ap_dz+ap_bremsen_step_strecke(r);
    end;
    ap_dz:=ap_dz+(abs(ap_spotx_err)+abs(ap_spoty_err))*50;
    ap_dz:=(ap_z-pz-vz*ap_dz)/ap_steps;

    taktt.tag:=_ap_hmflug;
    ap_pb.max:=ap_steps;ap_pb.position:=ap_steps;

    dosound(_snd_fast,true);
    ap_hmmove_ok:=true;
  end;

  //ende
  if ap_steps<=0 then begin
    ap_steps:=_ap_hmbremsen_steps;
    taktt.tag:=_ap_hmbremsen;
    ap_hmmove_ok:=false;
    exit;
  end;

  //flug-spruenge + zufaellige flug-schwankungen
  px:=ap_mark_x-ap_dx+randvz*ap_spotx_err;ap_mark_x:=px;px:=px+random(5)-random(5);
  py:=ap_mark_y-ap_dy+randvz*ap_spoty_err;ap_mark_y:=py;py:=py+random(5)-random(5);
  pz:=pz+ap_dz;

  dec(ap_steps);ap_pb.Position:=ap_steps;
end;

//autopilot: hypermove bremsstrecke berechnen --------------------
function thauptf.ap_bremsen_step_strecke(step:double):double;
begin
  result:=(step*step*step)/10000;
end;

//autopilot: hypermove abbremsen-------------------------
procedure thauptf.ap_hmbremsen;
var
  vz:integer;
begin
  //start
  if ap_steps=_ap_hmbremsen_steps then begin
    ap_gpb.Position:=ap_gpb.Position-1;
    px:=ap_mark_x;
    py:=ap_mark_y;
    ap_pb.max:=ap_steps;ap_pb.position:=ap_steps;
    dosound(_snd_fastbremsen,false);
  end;

  //ende
  if ap_steps<=0 then begin
    ap_gpb.Position:=ap_gpb.Position-1;
    taktt.tag:=_ap_ende;
    ap_pb.position:=0;
    exit;
  end;

  //vorzeichen: ziel auf sonne zu oder weg?
  if(ap_z-pz)>0 then vz:=1 else vz:=-1;

  //abbremsen
  ap_dz:=vz*ap_bremsen_step_strecke(ap_steps);
  pz:=pz+ap_dz;

  //turbinen gedrosselt?
  if ap_steps<40 then dosound(_snd_bremsen,false)

  //turbinen nich berdreht?
  else if ap_steps<_ap_hmbremsen_steps-20 then dosound(_snd_slow,true);

  dec(ap_steps);ap_pb.Position:=ap_steps;
end;

//autopilot-abbruch-------------------------------
procedure thauptf.ap_break;
var
  vz:integer;
begin
  if ap_steps=_ap_break_steps then begin
    ap_mark_z:=ap_dz/_ap_break_steps;

    if ap_hmmove_ok then begin
      //abbruch waehrend hypermove
      ap_dx:=random(20)-random(20);
      ap_dy:=random(20)-random(20);
      ap_dz:=random(20)-random(20);
      dosound(_snd_break,false);
    end
    else begin
      dosound(_snd_bremsen,false);
    end;
  end;

  //ende
  if ap_steps<=0 then begin
    taktt.tag:=_ap_ende;
    exit;
  end;

  //hypermove aktiv?
  if ap_hmmove_ok then begin
    //unkoordiniert schwingen
    rotx:=getangle(rotx+ap_dx);
    roty:=getangle(roty+ap_dy);
    rotz:=getangle(rotz+ap_dz);
  end;

  //abbremsen
  if(ap_z-pz)>0 then vz:=1 else vz:=-1;
  pz:=pz-vz*ap_mark_z;

  dec(ap_steps);ap_pb.Position:=ap_steps;
end;

//autopilot ist fertig-----------------
procedure thauptf.ap_ende;
begin
  ap_gpb.Position:=0;
  taktt.tag:=_ap_stop;
  cockpitp.Color:=clblack;
  apb.caption:='AutoPilot';
  ap_hmmove_ok:=false;
  dosound(_snd_stop,false);
end;

//--------------------------------------------------
procedure thauptf.doticker;
const
  _l=35;

  function fill(s:string):string;
  var
    i,c:integer;
  begin
    i:=(_l-length(s)) div 2;
    for c:=0 to i-2 do s:=' '+s;
    while length(s)<_l do s:=s+' ';
    result:='|'+s;
  end;

var
  s,ss:string;
  r:integer;
  i,ii:int64;
  d:double;
begin
  if not cockpitp.visible then exit;

  if tickerhint<>'' then begin
    //hint-ereignis hat tickerhint gefuellt
    s:=' *** '+fill(tickerhint);
  end
  else begin
    r:=zielsb.Position;
    d:=distance(px,py,pz,obja[r].x,obja[r].y,obja[r].z);
    i:=trunc(d/speed);

    if taktt.tag=_ap_stop then begin
      if i=0 then begin
        s:='Direktflug mglich';
      end
      else begin
        s:='';
        ii:=i div (60*60*24*365);
        if ii>0 then begin
          s:=s+inttostr(ii)+' Jahre ';
          i:=i mod (60*60*24*365);
        end;

        ii:=i div (60*60*24);
        if ii>0 then begin
          s:=s+inttostr(ii)+' Tage ';
          i:=i mod (60*60*24);
        end;

        if pos('Jahre',s)=0 then begin
          ii:=i div (60*60);
          if ii>0 then begin
            s:=s+inttostr(ii)+' Std. ';
            i:=i mod (60*60);
          end;

          if pos('Tage',s)=0 then begin
            ii:=i div 60;
            if ii>0 then begin
              s:=s+inttostr(ii)+' Min. ';
              i:=i mod 60;
            end;

            if pos('Std.',s)=0 then begin
              if i>0 then s:=s+inttostr(i)+' Sek.';
            end;
          end;
        end;
      end;
      s:=
        ' *** '+
        fill(getspeedtxt)+
        ' *** '+
        fill(uppercase(obja[zielsb.Position].name)+': '+s);
    end

    else if taktt.tag=_ap_richtung  then s:='Ausrichtung'
    else if taktt.tag=_ap_direkt    then s:='Direktflug'
    else if taktt.tag=_ap_hmstart   then s:='Beschleunigung'
    else if taktt.tag=_ap_hmflug    then s:='Hypermove'
    else if taktt.tag=_ap_hmbremsen then s:='Abbremsung'
    else if taktt.tag=_ap_break     then s:='ABBRUCH';

    if pos('*',s)=0 then s:=' *** '+fill(uppercase(obja[zielsb.Position].name)+': '+s);
  end;

  ss:=s;
  s:=copy(s,ticker+1,_l);
  if length(s)<_l then s:=s+copy(ss,1,_l-length(s));

  if (s<>'')and(s[1]='|') then begin
    inc(tickerblink);
    if tickerblink>15 then begin
      tickerblink:=0;
      inc(ticker);
    end
    else begin
      s:=stringreplace(s,'|',' ',[rfreplaceall]);
      if tickerblink mod 2=0 then s:='';
      tickere.Text:=s;
    end;
  end
  else begin
    s:=stringreplace(s,'|',' ',[rfreplaceall]);
    tickere.Text:=s;
    inc(ticker);
    if ticker>length(ss)then ticker:=0;
  end;
end;

//zurueck zum ursprung------------------
procedure thauptf.pos_home;
begin
  px:=0;py:=0;pz:=_erde_z;
  rotx:=0;roty:=0;rotz:=0;
end;

//springe zur letzten speicher-position
procedure thauptf.pos_load;
begin
  dosound(_snd_teleport,false);
  px:=sv_x;py:=sv_y;pz:=sv_z;
  rotx:=sv_rx;roty:=sv_ry;rotz:=sv_rz;
  sleep(1000);
end;

//merke aktuelle raum-position-------------
procedure thauptf.pos_save;
begin
  dosound(_snd_teleport,false);
  sv_x:=px;sv_y:=py;sv_z:=pz;
  sv_rx:=rotx;sv_ry:=roty;sv_rz:=rotz;
  sleep(1000);
end;

//--------------------------------------------------------------
procedure thauptf.dosound(typ:byte;loopok:bool);
var
  fn:string;
  uflags:cardinal;
begin
  if not soundok then exit;

  //spielt bereits gleicher sound?
  if typ=snd_typ then exit;

  //neuen sound auswaehlen
  snd_typ:=typ;
  case typ of
    _snd_stop       :fn:='';
    _snd_start      :fn:='snd_start.wav';
    _snd_slow       :fn:='snd_slow.wav';
    _snd_fast       :fn:='snd_fast.wav';
    _snd_bremsen    :fn:='snd_bremsen.wav';
    _snd_fastbremsen:fn:='snd_fastbremsen.wav';
    _snd_break      :fn:='snd_break.wav';
    _snd_teleport   :fn:='snd_teleport.wav';
  end;

  //ewig widerholen?
  uflags:=SND_ASYNC;if loopok then uflags:=uflags or SND_LOOP;
  if fn='' then sndPlaySound(nil,0)
           else sndPlaySound(pchar(homedir+fn),uflags);
end;


end.


